<script setup>
import { onMounted, ref, reactive, watch } from "vue";
import { storeToRefs } from "pinia";
import { useRouter } from "vue-router";
import { useMovieStore } from "../stores/movies";

const router = useRouter();
const movieStore = useMovieStore();
const { getMovies } = storeToRefs(movieStore);
const { fetchMovies } = movieStore;
const search = ref("");
let filteredMovies = ref([]);

watch(search, async (newSearch, oldSearch) => {
  if (newSearch) {
    filteredMovies.value = getMovies.value.filter((movie) =>
      movie.title.toLowerCase().includes(newSearch.toLowerCase())
    );
  } else {
    filteredMovies.value = getMovies.value;
  }
});

onMounted(() => {
  fetchMovies().then(() => {
    filteredMovies.value = getMovies.value;
  });
});

function genresFormated(genres) {
  let formatedGenres = genres[0];

  if (genres.length > 1) {
    for (let i = 1; i < genres.length; i++) {
      formatedGenres += " / " + genres[i];
    }
  }

  return formatedGenres;
}

function gotoMovieAdd() {
  router.push("/add");
}

function gotoMovieUpdate(id) {
  router.push(`/${id}`);
}
</script>

<template>
  <div class="page-wrapper">
    <header>
      <div class="title">Movies Collection</div>
    </header>
    <section class="card-wrapper">
      <div class="search-container">
        <q-input
          v-model="search"
          debounce="500"
          outlined
          placeholder="Search by title"
        >
          <!-- <template v-slot:append>
            <q-icon name="search" />
          </template> -->
        </q-input>
      </div>
      <div class="row card-container q-gutter-lg">
        <div
          v-for="movie in filteredMovies"
          :key="movie.id"
          class="col-xs-12 col-sm-6 col-md-3"
        >
          <q-card
            style="border-radius: 12px; cursor: pointer"
            @click="gotoMovieUpdate(movie.id)"
          >
            <q-card-section>
              <div style="font-weight: 700">{{ movie.title }}</div>
              <div>{{ movie.director }}</div>
            </q-card-section>
            <q-card-section class="q-pt-none">
              <div style="text-align: end">
                {{ genresFormated(movie.genres) }}
              </div>
            </q-card-section>
          </q-card>
        </div>
      </div>
    </section>
    <section class="cta-container">
      <q-btn fab icon="add" @click="gotoMovieAdd" style="background: #fff" />
    </section>
  </div>
</template>

<style lang="scss" scoped>
.page-wrapper {
  height: inherit;
  padding: 0 0 16px 0;

  header {
    padding: 16px 0;
    border-bottom: 1px solid;
    position: fixed;
    top: 0;
    left: 0;
    right: 0;
    z-index: 2;
    background: #fff;
    min-width: 375px;

    .title {
      text-align: center;
      font-size: 1.5rem;
      font-weight: 700;
    }
  }

  .card-wrapper {
    padding: 85px 16px 0 16px;
    height: calc(100% - 69px);
    min-width: 375px;

    .search-container {
      margin-bottom: 20px;
    }

    .card-container {
      width: 100%;
    }
  }

  .cta-container {
    display: inline-block;
    padding: 16px 16px;
    position: fixed;
    bottom: 0;
    right: 0;
    z-index: 2;
  }
}

@media screen and (min-width: 600px) and (max-width: 1023px) {
  .page-wrapper {
    .card-container {
      justify-content: space-around;
    }
  }
}
</style>

<style>
.search-container .q-field__control.relative-position.row.no-wrap {
  height: 48px;
  border-radius: 8px;
}
</style>
